<template>
  <header :class="$style.header">
    <the-nav-bar>
      <template #logo>
        <router-link to="/">logo</router-link>
      </template>
      <template #nav-items>
        <the-nav-item href="/product/1"> Product details </the-nav-item>
        <the-nav-item href="/cart">Cart</the-nav-item>
        <the-action-bar v-responsive:max-width="'768px'">
          <div :class="$style.actionBarItem" @click="handleAuthAction">
            {{ authButtonText }}
          </div>
        </the-action-bar>
      </template>
    </the-nav-bar>
  </header>
</template>

<script lang="ts">
/* eslint-disable @typescript-eslint/ban-ts-ignore */

import Vue from "vue";
// components
import TheNavBar from "@/layout/TheNavBar/TheNavBar.vue";
import TheNavItem from "@/layout/TheNavItem/TheNavItem.vue";
import TheActionBar from "@/layout/TheActionBar/TheActionBar.vue";
import AuthMixin from "../../mixins/Auth";

export default Vue.extend({
  name: "TheHeader",
  mixins: [AuthMixin],
  components: {
    TheNavBar,
    TheNavItem,
    TheActionBar,
  },
  computed: {
    authButtonText: function() {
      // @ts-ignore
      if (this.isAuthenticatedFromAuthMixin) {
        return "Logout";
      } else {
        return "Login";
      }
    },
  },
  methods: {
    handleAuthAction: function() {
      // @ts-ignore
      if (!this.isAuthenticatedFromAuthMixin) {
        // @ts-ignore
        this.loginUserFromAuthMixin();
      } else {
        // @ts-ignore
        this.logOutUserFromAuthMixin();
      }
    },
  },
  watch: {
    isAuthenticatedFromAuthMixin: function(isAuthenticated) {
      if (!isAuthenticated) {
        this.$router.push("/");
      }
    },
  },
});
</script>

<style module lang="scss">
.header {
  box-shadow: $shadow--default;
}
.logo {
  composes: max-width--100;
  width: 100px;
}
.actionBarItem {
  padding: 0 1rem;
  color: $color--primary;
  cursor: pointer;
  &:first-child {
    padding-left: 1rem;
  }
}

@media screen and (max-width: $device-size--desktop-laptop) {
  .actionBarItem {
    padding-right: 0;
  }
}
@media screen and (max-width: $device-size--tablet) {
  .actionBarItem {
    padding-right: 0;
  }
}
</style>
